// basinCellNR.h

//----------------------------------------------------------------------
//	BasinCellNR		$B%;%kFbIt$r7W;;$9$k%/%i%9(B
//----------------------------------------------------------------------

#if !defined(_basinCellNR_h)
#define _basinCellNR_h

#include <stdio.h>
#include <math.h>

#include "vary.h"		// $B%/%i%9(B Vary $B$NDj5A(B
#include "segmentNR.h"	// $B%/%i%9(B SegmentNR $B$NDj5A(B
#include "fldstruct.h"	// $B9=B$BN$NDj5A(B

//	$B%/%i%9(B BasinCellNR $B$NDj5A(B

class BasinCellNR {

//	$B%Q%i%a%?(B

  protected:
	int n_node;		// $B%N!<%I$N?t(B
	int n_seg;		// $B2OF;6hJ,$N?t(B
	int n_tan;		// $B7W;;C<E@$N?t(B( = $BJ,9gN.E@$r4^$^$J$$%N!<%I$N?t(B)
	int n_cnfl;		// $B?^3TFbIt$NJ,9gN.E@$N?t(B( = n_node - n_tan )
	int n_ur;		// $B:G>eN.C<6-3&$N?t(B
	int n_lr1;		// $B:G2<N.C<6-3&(B 1 $B$N?t(B($B2<N.C<6-3&$O?e0L%O%$%I%m%0%i(B
					// $B%U(B)
	int n_lr2;		// $B:G2<N.C<6-3&(B 2 $B$N?t(B($B2<N.C<6-3&$O(B Q-h $B4X78<0(B)
	int n_change;	// $BL$CNNL$N8r49$N2s?t(B

	double L_sum;	// $B3F2OF;6hJ,$N2OF;D9(B L $B$NAmOB(B
	int** v_array;	// $BL$CNNL$NJB$YJQ$($r5-21$9$kG[Ns(B

	Boolean Qflag;	// $B7W;;=*N;H=DjMQ%U%i%0(B ($BN.NL(B)
					// $B=*$C$F$$$?$i(B YES ($BITEyN.7W;;MQ(B)
	Boolean Hflag;	// $B7W;;=*N;H=DjMQ%U%i%0(B ($B?e?<(B)
					// $B=*$C$F$$$?$i(B YES ($BITEyN.7W;;MQ(B)
// 	$B>uBVNL(B

  protected:
	double** M_node;	// $B%N!<%I$G$NJ}Dx<0$N78?t9TNs(B
						// (n_seg * 4 - n_tan $B!_(B n_seg * 4 $B$N9TNs(B)
	Vdary F_node;		// $B%N!<%I$G$NJ}Dx<0$NDj?t%Y%/%H%k(B
						// (n_seg * 4 - n_tan $B$N%Y%/%H%k(B)
	int** d_node;		// $B%N!<%I$G$NJ}Dx<0$NL$CNNL$N=gHV$NG[Ns(B
						// (n_seg * 4 $B!_(B 2 $B$NG[Ns(B)
						// d_node[i][0] : $B2OF;6hJ,HV9f(B
						// d_node[i][1] : $B%N!<%I$NJ,N`(B  0 $B>eN.B&N.NL(B 
						// 1 $B>eN.B&?e?<(B  2 $B2<N.B&N.NL(B  3 $B2<N.B&?e?<(B

	SegmentNR* seg;			// $BC10l2OF;%/%i%9(B SegmentNR $B$N%*%V%8%'%/%H(B
	NodeType* nt;;			// $B9=B$BN(B NodeType
	Confluence* cnfl;		// $B9=B$BN(B Confluence
	PositionOfVariable* pv;	// $B9=B$BN(B PositionOfVariable

//	$B%3%s%9%H%i%/%?!&%G%9%H%i%/%?(B

  public:
	BasinCellNR(void) {}
	~BasinCellNR(void);

//	$B%Q%i%a%?$N@_Dj!&>uBVNL$N=i4|2=!&:G=*>uBVNL$NJ]B8(B

  public:
	Boolean Set_parameter(FILE* fp, time_t time_step);
	Boolean Set_init_for_varied(FILE* fp);
	// $BITEyN.$N7W;;$N$?$a$N=i4|>uBVNL$r@_Dj(B
	Boolean Set_init_for_runoff(FILE* fp, double lat);
	// $BN.=P7W;;$N$?$a$N=i4|>uBVNL$r@_Dj(B
	// lat : $B%;%kA4BN$G$NB&J}N.F~NL$NAmOB(B
	Boolean Save_terminal_state(FILE* fp);
	// $B:G=*>uBVNL$rJ]B8(B

//	$B%/%i%9(B BasinCellNR $B$KFCM-$N4X?t(B

	// $BN.=P7W;;(B

	Boolean Make_equation(time_t time_step);
	// $B%N!<%I$G$NO"N)J}Dx<0$r$?$F$k4X?t!#(B
	Boolean Sweep_equation(double**& M, Vdary& F);
	// $B9gN.ItJ,$NA]$-=P$7$r9T$J$&4X?t!#(B
	// M : $BA]$-=P$78e$N78?t9TNs(B
	// F : $BA]$-=P$78e$NDj?t%Y%/%H%k(B
	void Renewal(Vdary v_cn);
	// $B7W;;C<E@$G$N(B dq, dh $B$r<u$1<h$j!"3F%N!<%I$G$N(B dq, dh $B$r5a$a!"$=$l(B
	// $B$>$l$N2OF;6hJ,$KEO$94X?t!#(B
	// v_cn : $B7W;;C<E@$G$N(B dq, dh
	void Reset_variable(void);
	// $B3F2OF;6hJ,$K$*$1$k>uBVNL$r(B next_time $B$N$b$N$K99?7$9$k!#(B

	// $BITEyN.$N7W;;(B

	Boolean Calc_discharge(Viary sn, Vdary q);
	// $B%;%kFb$NN.NL$NJ,I[$r7W;;$9$k4X?t!#(B
	// sn : $B>eN.C<$,6-3&E@$N2OF;$N2OF;6hJ,HV9f(B
	// q : $B>eN.C<$G$NN.NL(B
	Boolean Calc_depth(Viary sn, Vdary h);
	// $B%;%kFb$N?e?<$r7W;;$9$k4X?t!#(B
	// sn : $B2<N.C<$,6-3&E@$N2OF;$N2OF;6hJ,HV9f(B
	// h : $B2<N.C<$G$N?e?<(B
	Boolean Re_q(int sn, double& q);
	// $B;XDj$5$l$?2OF;$N2<N.C<$NN.NL$rJV$94X?t!#(B
	// $B$^$@7W;;$5$l$F$$$J$+$C$?$i(B NO $B$rJV$7$^$9!#(B
	Boolean Re_h(int sn, double& h);
	// $B;XDj$5$l$?2OF;$N>eN.C<$N?e?<$rJV$94X?t!#(B
	// $B$^$@7W;;$5$l$F$$$J$+$C$?$i(B NO $B$rJV$7$^$9!#(B
	void Re_num_of_bp(Viary& sn_up, Viary& sn_low);
	// $B>e2<N.C<$K6-3&E@$r;}$D2OF;$N2OF;6hJ,HV9f$rJV$94X?t!#(B

	Boolean Connect_segment(FILE* fp);
	// $B@\B34X78%U%!%$%k$+$i%;%kFb$N2OF;6hJ,$r@\B3$9$k4X?t!#(B
	Boolean Set_position_of_variable(void);
	// $BL$CNNL$N0LCV$rG[Ns$K5-21$9$k4X?t(B
	void Ready_for_calculate(double lat, Vdary qup, Vdary hlow);
	// $B7W;;$N=`Hw$r9T$J$&4X?t!#(B
	// lat : next_time $B$G$NB&J}N.F~NL(B
	// qup : $B>eN.C<6-3&$G$NN.NL(B
	// hlow : $B2<N.C<6-3&$G$N?e0L(B

	void Re_lowest_q(Vdary& qlr);
	// $B:G2<N.C<$G$NN.NL$rJV$94X?t!#(B
	double Re_variable(int sn, ULFlag ul, QHFlag qh);
	// $B;XDj$5$l$?2OF;6hJ,HV9f$N(B next_time $B$G$N2OF;$N>e2<N.C<$G$N>uBVNL(B
	// $B$rJV$94X?t!#(B
	// sn : $B2OF;6hJ,HV9f(B ul : $B>e2<N.C<$N6hJL(B(UPPER or LOWER)
	// qh : $BN.NL$+?e?<$+$N6hJL(B(DISCHARGE or DEPTH)
	int Re_position_of_variable(int sn, ULFlag ur, QHFlag qh);
	// $B;XDj$5$l$?2OF;6hJ,HV9f$N2OF;$NL$CNNL$N0LCV$rJV$94X?t!#(B
	// sn : $B2OF;6hJ,HV9f(B ul : $B>e2<N.C<$N6hJL(B(UPPER or LOWER)
	// qh : $BN.NL$+?e?<$+$N6hJL(B(DISCHARGE or DEPTH)
	Boolean Output_variable(Vdary*& Qall, Vdary*& Hall, CNFlag s);
	// $B3F2OF;6hJ,$NA47W;;CGLL$G$NN.NL5Z$S?e?<$rJV$94X?t!#(B
	// s : CURRENT or NEXT
	void Re_ur(Viary& ur);
	// $B:G>eN.C<6-3&$N2OF;6hJ,HV9f$rJV$94X?t!#(B
	void Re_lr1(Viary& lr1);
	// $B:G2<N.C<6-3&(B 1 $B$N2OF;6hJ,HV9f$rJV$94X?t!#(B
	void Re_lr2(Viary& lr2);
	// $B:G2<N.C<6-3&(B 2 $B$N2OF;6hJ,HV9f$rJV$94X?t!#(B
	int Re_sum_of_cs(void);
	// $B3F2OF;6hJ,$N7W;;CGLL?t$NOB$rJV$94X?t!#(B

	inline int Re_num_of_seg(void) { return n_seg; }
	// $B2OF;6hJ,?t$rJV$94X?t!#(B
	inline int Re_comp_node(void) {	return n_tan; }
	// $B7W;;C<E@$N?t$rJV$94X?t!#(B
	inline int Re_ur(void) { return n_ur; }
	// $B:G>eN.C<6-3&$N?t$rJV$94X?t!#(B
	inline int Re_lr1(void) { return n_lr1; }
	// $B:G2<N.C<6-3&(B 1 $B$N?t$rJV$94X?t!#(B
	inline int Re_lr2(void) { return n_lr2; }
	// $B:G2<N.C<6-3&(B 2 $B$N?t$rJV$94X?t!#(B
	Boolean Re_Qflag(void);
	// Qflag $B$rJV$94X?t!#(B($BITEyN.7W;;MQ(B)
	Boolean Re_Hflag(void);
	// Hflag $B$rJV$94X?t!#(B($BITEyN.7W;;MQ(B)
};

#endif	// ! _basinCellNR_h
