// fldDynaNR.h

//----------------------------------------------------------------------
//	FldDynaNR		$B2OF;LV%b%G%k(B
//----------------------------------------------------------------------

#if !defined(_fldDynaNR_h)
#define _fldDynaNR_h

#include <stdio.h>
#include <time.h>
#include <math.h>

#include "common.h"		// $B6&DL4D6-$NDj5A(B
#include "element.h"	// $B%/%i%9(B Element $B$NDj5A(B
#include "p_tmp.h"		// $B%F%s%W%l!<%H%/%i%9(B Receive, Send $B$NDj5A(B
#include "vary.h"		// $B%/%i%9(B Vary $B$NDj5A(B
#include "grid.h"		// $B%/%i%9(B Grid $B$NDj5A(B
#include "segmentNR.h"	// $B%/%i%9(B SegmentNR $B$NDj5A(B
#include "basinCellNR.h"	// $B%/%i%9(B BasinCellNR $B$NDj5A(B
#include "fldSlope.h"	// $B%/%i%9(B FldSlope $B$NDj5A(B
#include "fldstruct.h"	// $B9=B$BN$NDj5A(B

#define EPSQ 0.001		// $B<}B+H=DjCM$NDj5A(B
#define EPSH 0.001		// $B<}B+H=DjCM$NDj5A(B

typedef Vary<double> Vdary;
typedef Vary<int> Viary;

//	 $B%/%i%9(B FldDynaNR $B$NDj5A(B

class FldDynaNR : public Element {

//	$B%Q%i%a%?(B

  protected:
	size_t n_row;		// $B9T$N?t(B
	size_t n_col;		// $BNs$N?t(B
	size_t n_cell;		// $BA4%;%k$N?t(B (= n_row * n_col)
	int n_parts;		// $B7W;;CGLL$G$N>uBVNL$,I,MW$J%;%k$N?t(B
	int n_cn;			// $BA47W;;C<E@$N?t(B
	int n_upper;		// $B>eN.C<6-3&$N?t(B
	int n_lower1;		// $B2<N.C<6-3&(B 1 $B$N?t(B($B?e0L%O%$%I%m%0%i%U(B)
	int n_lower2;		// $B2<N.C<6-3&(B 2 $B$N?t(B(Q-h $B4X78<0(B)
	int n_is;			// $B?^3T$H2OF;6hJ,$N8rE@$N?t(B($B>e2<N.C<$O4^$^$J$$(B)
						// n_is = n_cn - (n_upper + n_lower1 +
						// n_lower2)
	int n_max;			// $B3F%;%k$K$*$1$k7W;;C<E@$N?t$N:GBgCM(B
	double Qlevel;		// $BN.NL$NBeI=CM(B($B<}B+H=DjMQ(B)
	double Hlevel;		// $B?e?<$NBeI=CM(B($B<}B+H=DjMQ(B)
	time_t t_step;		// $B7W;;;~4V4V3V(B($BA4$F$N2OF;6&DL(B)
	time_t predt;		// $B0l$DA0$N%?%$%`%9%F%C%W(B

	SwitchFlag sflag;	// RUNOFF : $BN.=P7W;;(B
						// VARIED : $BITEyN.$N7W;;(B($B7W;;7k2L$ON.=P7W;;$N(B
						// $B=i4|>uBVNL$H$J$k(B)
// 	$B>uBVNL(B

  protected:
	double** M_all;		// $B7W;;C<E@$G$NJ}Dx<0$N78?t9TNs(B
	double** M_fixed;	// $B8GDjItJ,$r5-21$9$k9TNs(B
	Vdary F_all;		// $B7W;;C<E@$G$NJ}Dx<0$NDj?t%Y%/%H%k(B
	Vdary x_all;		// $B7W;;C<E@$G$NN.NL$*$h$S?e?<$NJd@5NL(B
	double** M_cell;	// $B3F%;%k$G$NA]$-=P$78e$N78?t9TNs(B
	Vdary F_cell;		// $B3F%;%k$G$NA]$-=P$78e$NDj?t%Y%/%H%k(B

//	$B%G!<%?%a%s%P(B

  protected:
	Grid<BasinCellNR> bc;		// BasinCellNR $B7?$N(B Grid 
	Grid<int> position;			// int $B7?$N(B Grid
								// $B7W;;C<E@$N?t$r5-21$9$kG[Ns(B(0, 5,
	BoundaryPoint* bp;			// $B9=B$BN(B BoundaryPoint
								// $B?^3T$H8r$o$k2OF;$N?^3THV9f$H2OF;(B
								// $B6hJ,HV9f$r5-21$9$kG[Ns(B
	QHRelation* qhr;			// $B9=B$BN(B QHRelation
								// Q-h $B4X78<0$N(Ba, b $B5Z$S2<N.C<$NI89b(B
								// $BCM$r5-21$9$kG[Ns(B
	CellNumber* cn;				// $B9=B$BN(B CellNumber
								// $B7W;;CGLL$G$N>uBVNL$,I,MW$J%;%k$N(B
								// $B?^3THV9f$r5-21$9$kG[Ns(B
	Grid<Viary> sn_up;			// Viary $B7?$N(B Grid
								// $B>eN.$,6-3&E@$G$"$k2OF;$N2OF;6hJ,(B
								// $BHV9f$r5-21$9$kG[Ns(B($BITEyN.MQ(B)
	Grid<Viary> sn_low;			// Viary $B7?$N(B Grid
								// $B2<N.$,6-3&E@$G$"$k2OF;$N2OF;6hJ,(B
								// $BHV9f$r5-21$9$kG[Ns(B($BITEyN.MQ(B)
	Grid<BoundaryPoint> bp_in;	// BoundaryPoint $B7?$N(B Grid
								// $B<+J,$KN.F~$9$k2OF;$N?^3THV9f$H2O(B
								// $BF;6hJ,HV9f$r5-21$9$kG[Ns(B($BITEyN.MQ(B)
	Grid<BoundaryPoint> bp_out;	// BoundaryPoint $B7?$N(B Grid
								// $B<+J,$+$iN.=P$9$k2OF;$N?^3THV9f$H2O(B
								// $BF;6hJ,HV9f$r5-21$9$kG[Ns(B($BITEyN.MQ(B)
//	$B<u?.C<;R(B

  protected:
	Receive<double>* rp_up;		// $B>eN.C<6-3&$+$i$NN.F~<hF@MQ(B
	Receive<double>* rp_low;	// $B2<N.C<6-3&$+$i$N?e0L<hF@MQ(B
	void Register_receive_ports(void);

//	$BAw?.C<;R(B

	Send<double>* sp;		// $B2<N.C<6-3&$G$NN.NL=PNOMQ(B
	Send<Vdary>* sp_q;		// $BA47W;;CGLL$G$NN.NL=PNOMQ(B
	Send<Vdary>* sp_h;		// $BA47W;;CGLL$G$N?e?<=PNOMQ(B
	void Register_send_ports(void);

//	$B=i4|2=4X?t!&%3%s%9%H%i%/%?!&%G%9%H%i%/%?(B

  private:
	FldDynaNR& operator=(const FldDynaNR& rhs);
	// $BBeF~$r6X;_$9$k$?$a$N@k8@!#<BAu$O$7$J$$!#(B

  public:
	Boolean Init(char* o_name, int o_num, size_t num_row, size_t
				 num_col, char* f_grid, char* f_all, char* f_cell,
				 SwitchFlag sf);
	// o_name	$B%*%V%8%'%/%HL>(B
	// o_num	$B%*%V%8%'%/%HHV9f(B
	// num_row	$B9T$N?t(B
	// num_col	$BNs$N?t(B
	// f_grid	$B>uBVNL$r<hF@$7$?$$2OF;6hJ,$r5-O?$7$?%U%!%$%k$N%U%!%$%kL>(B
	// f_all	$B2OF;LVA4BN$N@\B34X78%U%!%$%k$N%U%!%$%kL>(B
	// f_cell	$B3F%;%kFb$N@\B34X78%U%!%$%k$N%U%!%$%kL>(B
	// sf		$B7W;;$NH=CGMQ%U%i%0(B(RUNOFF or VARIED)

	FldDynaNR(char* o_name, int o_num, size_t num_row, size_t num_col,
			char* f_grid, char* f_all, char* f_cell, SwitchFlag sf);
	FldDynaNR(void);
	~FldDynaNR(void);

//	$B%Q%i%a%?$N@_Dj!&>uBVNL$N=i4|2=!&:G=*>uBVNL$NJ]B8(B

  protected:
	void Set_parameter(FILE* fp);
	void Set_initial_state(FILE* fp);
	void Save_terminal_state(FILE* fp);

//	$B7W;;5!G=(B

  protected:
	Boolean Initial_output(void);
    time_t Calculate_time_step(void) { return t_step; }
	Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
	// Can_you_calculate0 : time_step $B8e$N%G!<%?$r<hF@$G$-$k$+$I$&$+$r(B
	// $BH=CG$9$k4X?t!#(B
	Boolean Work(void) { return Work0(); }
	Boolean Calculate(void);

//	$B%/%i%9(B FldDynaNR $B$KFCM-$N4X?t(B

	// $BN.=P7W;;(B

	void Make_equation(void);
	// $BO"N)J}Dx<0$r$?$F$k4X?t!#(B
	void Solve_equation(void);
	// $BO"N)J}Dx<0$r2r$/4X?t!#(B
	Boolean Renewal(void);
	// $B?dDjCM$N99?7$r9T$J$&4X?t!#(B
	void Re_a_and_b(size_t r, size_t c, int s, Vdary& v);
	// $B?^3THV9f$H2OF;6hJ,HV9f$+$i(B Q-H $B4X78<0$K$*$1$k(B a, b $B$rJV$94X?t!#(B

	// $BITEyN.$N7W;;(B

	void Calc_discharge(void);
	void Calc_depth(void);
};

#endif	// ! _fldDynaNR_h
