// fldstruct.h

//--------------------------------------------------------------
//	fldstruct.h	$B9=B$BN%U%!%$%k(B
//--------------------------------------------------------------

#if !defined(_fldstruct_h)
#define _fldstruct_h

#include "vary.h"

typedef Vary<double> Vdary;
typedef Vary<int> Viary;

enum SwitchFlag {RUNOFF, VARIED};
enum ULFlag {UPPER, LOWER};
enum QHFlag {DISCHARGE, DEPTH};
enum CNFlag {CURRENT, NEXT};

//	$B9=B$BN(B CellNumber $B$NDj5A(B

struct CellNumber {

	size_t row;		// $B9THV9f(B
	size_t col;		// $BNsHV9f(B

};

//	$B9=B$BN(B BoundaryPoint $B$NDj5A(B

struct BoundaryPoint {

	Viary row;		// $B9THV9f(B
	Viary col;		// $BNsHV9f(B
	Viary segnum;	// $B2OF;6hJ,HV9f(B
};

//	$B9=B$BN(B Confluence $B$NDj5A(B

struct Confluence {

	int nodenum;		// $B%N!<%IHV9f(B
	int nodesum;		// $B$=$N%N!<%I$KN.=PF~$9$k2OF;6hJ,$N?t(B
	Viary segnum;	// $B$=$N%N!<%I$KN.=PF~$9$k2OF;6hJ,$NHV9f(B
						// $BN.F~$9$k;~$O@5!"N.=P$9$k;~$OIi(B
};

//	$B9=B$BN(B NodeType $B$NDj5A(B

struct NodeType {

	int nodenumber;	// $B%N!<%IHV9f(B
	int attribute;	// $B%N!<%I$NB0@-(B	
					// 0 : $BJ,9gN.E@(B	
					// 1 : $B6-3&E@(B
					// 2 : $B:G>eN.C<6-3&(B
					// 3 : $B:G2<N.C<6-3&(B 1 ($B?e0L%O%$%I%m%0%i%U(B)
					// 4 : $B:G2<N.C<6-3&(B 2 (Q - h $B4X78<0(B)
};

//	$B9=B$BN(B QHRelation $B$NDj5A(B

struct QHRelation {

	size_t row;		// $B?^3THV9f(B($B9T(B)
	size_t col;		// $B?^3THV9f(B($BNs(B)
	int segnum;		// $B2OF;6hJ,HV9f(B
	double a;		// Q-H $B4X78<0(B Q = a(H + b)^2 $B$K$*$1$k(B a
	double b;		// Q-H $B4X78<0(B Q = a(H + b)^2 $B$K$*$1$k(B b
	double zlow;	// $B:G2<N.C<$G$NI89b(B
};

//	$B9=B$BN(B PositionOfVariable $B$NDj5A(B

struct PositionOfVariable {

	int segnum;			// $B2OF;6hJ,HV9f(B
	int upposition;		// $B>eN.C<N.NL$N0LCV(B
	int lowposition;	// $B2<N.C<N.NL$N0LCV(B
};

#endif	// ! _fldstruct_h
